package fr.imag.wifibot.gps;

public class ChecksumTest {	
	
	public static boolean isValid(String msg) {		
		return GetCheckSum(msg).equalsIgnoreCase(msg.substring(msg.indexOf('*')+1));
	}
	
	private static String GetCheckSum(String msg) {
        int chk = 0;
        
        for (int i = 1; i < msg.indexOf('*'); i++) {
            chk ^= msg.charAt(i);
        }
        
        String chk_s = Integer.toHexString(chk).toUpperCase();
        
        while (chk_s.length() < 2) {
            chk_s = "0" + chk_s;
        }
        
        return chk_s;
    }
}
